import { ReactNode } from 'react';
declare type Props<T> = {
    [P in keyof T]?: any;
} & {
    children?: ReactNode;
};
export declare type Config<T> = {
    type?: string;
    className?: string;
    style?: (props: Props<T>) => any;
    extend?: (props: Props<T>) => any;
    render?: (props: Props<T>) => any;
};
declare const factory: <T>({ type, className: baseClass, style, extend, render }: Config<T>) => import("react").ForwardRefExoticComponent<Pick<any, string | number | symbol> & import("react").RefAttributes<unknown>>;
export default factory;
